'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _events = require('events');

var _events2 = _interopRequireDefault(_events);

var _pImmediate = require('p-immediate');

var _pImmediate2 = _interopRequireDefault(_pImmediate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Debug.
 *
 * @type {Function}
 */

var debug = (0, _debug2.default)('nexus:pubsub-memory');

/**
 * The default, memory-only pubsub adapter.
 *
 * @type {MemoryPubsub}
 */

var MemoryPubsub = function (_Emitter) {
  _inherits(MemoryPubsub, _Emitter);

  function MemoryPubsub() {
    _classCallCheck(this, MemoryPubsub);

    return _possibleConstructorReturn(this, (MemoryPubsub.__proto__ || Object.getPrototypeOf(MemoryPubsub)).apply(this, arguments));
  }

  _createClass(MemoryPubsub, [{
    key: 'subscribe',


    /**
     * Subscribe to a document channel by `id`.
     *
     * @param {String} id
     */

    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(id) {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                debug('subscribe', { id: id });

              case 1:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function subscribe(_x) {
        return _ref.apply(this, arguments);
      }

      return subscribe;
    }()

    /**
     * Unsubscribe from a document channel by `id`.
     *
     * @param {String} id
     */

  }, {
    key: 'unsubscribe',
    value: function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(id) {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                debug('unsubscribe', { id: id });

              case 1:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function unsubscribe(_x2) {
        return _ref2.apply(this, arguments);
      }

      return unsubscribe;
    }()

    /**
     * Publish `message` to a document channel by `id`.
     *
     * @param {String} id
     * @param {Object} message
     */

  }, {
    key: 'publish',
    value: function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(id, message) {
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                debug('publish', { id: id, message: message });
                _context3.next = 3;
                return (0, _pImmediate2.default)();

              case 3:
                this.emit('publish', id, message);

              case 4:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function publish(_x3, _x4) {
        return _ref3.apply(this, arguments);
      }

      return publish;
    }()
  }]);

  return MemoryPubsub;
}(_events2.default);

/**
 * Export.
 *
 * @type {MemoryPubsub}
 */

exports.default = MemoryPubsub;